/* Zodiac - LogFile.cpp
 */

#include "LogFile.h"
#include <stdarg.h>

static char logBuffer[256];

LogFile::LogFile()
{
	m_logFile = NULL;
}

LogFile::~LogFile()
{
	this->close();
}

bool LogFile::open(const char *fileName)
{
	// ignore garbage filenames
	if (!fileName || !fileName[0]) return false;

	// If there was already a file open, close it.
	this->close();
	m_logFile = fopen(fileName, "wt");
	return (m_logFile != NULL);
}

void LogFile::close()
{
	if (m_logFile != NULL) fclose(m_logFile);
	m_logFile = NULL;
}

int LogFile::printf(const char *format, ...)
{
	if (!m_logFile) return -1;

	va_list args;
	va_start(args, format);
	// Here's that non-thread-safe part
	int count = _vsnprintf(logBuffer, 256, format, args);
	va_end(args);

	fputs(logBuffer, m_logFile);
	return count;
}
