/* Zodiac - ModelViewer.h
 * A simple model viewing app to quickly test the basics.
 */

#ifndef Zodiac_ModelViewer_h
#define Zodiac_ModelViewer_h

#include "Texture.h"
#include "UiContext.h"
#include "Md2Model.h"
#include "Common.h"
#include "LogFile.h"

class ModelViewer
{
private:
	UiContext *ui;

	Texture *m_background;

	float m_modelAngle;
	Md2Model *m_model;
	Texture  *m_modelTxr;
	int m_modelFrame;
	int m_modelNextFrame;
	float m_modelLerp;

	int m_numModels;
	int m_modelPage;

	std::list<std::string> m_fileList;
	int m_displayWidth, m_displayHeight;

	LogFile m_log;

	void loadModel(std::string model);

public:
	ModelViewer();
	~ModelViewer();

	bool loadResources();
	bool doFrame(double deltaTime);
	bool doMenu();
	void doModel(double deltaTime);

	int run(int width, int height, char *logFile = NULL);
};

#endif // include guard
