/* Zodiac - Renderer.h
*/

#ifndef Zodiac_Renderer
#define Zodiac_Renderer

#include "prmath/vector3.hpp"
#include "prmath/matrix4x4.hpp"

struct ViewInfo
{
	vec3f position;
	matrix4x4f orientation;

	float fov_x, fov_y;
	float zNear, zFar;

	ViewInfo()
	{
		position.SetVector(0, 0, 0);
		orientation.Identity();
		fov_x = 120.0f;
		fov_y = 90.0f;
		zNear = 1.0f;
		zFar = 2048.0f;
	}
};

class Renderer
{
private:
	ViewInfo m_viewInfo;

	vec3f      m_cameraPos;
	matrix4x4f m_cameraMat;

public:
	Renderer();
	~Renderer();

	void clearScreen(float r = 0, float g = 0, float b = 0, float depth = 1.0f);
    void resetMatrices();
    void swapBuffers();
};

#endif // include guard
